Index: issm/branches/trunk-jpl-damage/src/c/modules/SurfaceLogVelMisfitx/SurfaceLogVelMisfitx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SurfaceLogVelMisfitx/SurfaceLogVelMisfitx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SurfaceLogVelMisfitx/SurfaceLogVelMisfitx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/SurfaceLogVxVyMisfitx/SurfaceLogVxVyMisfitx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SurfaceLogVxVyMisfitx/SurfaceLogVxVyMisfitx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SurfaceLogVxVyMisfitx/SurfaceLogVxVyMisfitx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/SurfaceRelVelMisfitx/SurfaceRelVelMisfitx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SurfaceRelVelMisfitx/SurfaceRelVelMisfitx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SurfaceRelVelMisfitx/SurfaceRelVelMisfitx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/SystemMatricesx/SystemMatricesx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SystemMatricesx/SystemMatricesx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SystemMatricesx/SystemMatricesx.cpp	(revision 12878)
@@ -10,5 +10,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void SystemMatricesx(Matrix** pKff, Matrix** pKfs, Vector** ppf, Vector** pdf, double* pkmax,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,bool kflag,bool pflag,bool penalty_kflag,bool penalty_pflag){
+void SystemMatricesx(Matrix** pKff, Matrix** pKfs, Vector** ppf, Vector** pdf, IssmDouble* pkmax,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,bool kflag,bool pflag,bool penalty_kflag,bool penalty_pflag){
 	
 	/*intermediary: */
@@ -25,8 +25,8 @@
 	Vector*    pf   = NULL;
 	Vector*    df=NULL;
-	double kmax = 0;
+	IssmDouble kmax = 0;
 
 	/*Display message*/
-	_printf_(VerboseModule(),"   Generating matrices\n");
+	if(VerboseModule()) _pprintLine_("   Generating matrices");
 
 	/*retrive parameters: */
@@ -41,5 +41,5 @@
 	numberofdofspernode=nodes->MaxNumDofs(configuration_type,GsetEnum);
 
-	/*Checks in debugging mode {{{1*/
+	/*Checks in debugging mode {{{*/
 	if(penalty_kflag)_assert_(kflag);
 	if(penalty_pflag)_assert_(pflag);
Index: issm/branches/trunk-jpl-damage/src/c/modules/SystemMatricesx/SystemMatricesx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SystemMatricesx/SystemMatricesx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SystemMatricesx/SystemMatricesx.h	(revision 12878)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void SystemMatricesx(Matrix** pKff, Matrix** pKfs, Vector** ppf, Vector** pdf, double* pkmax,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,
+void SystemMatricesx(Matrix** pKff, Matrix** pKfs, Vector** ppf, Vector** pdf, IssmDouble* pkmax,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,
 			bool kflag=true,bool pflag=true,bool penalty_kflag=true,bool penalty_pflag=true);
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/ThicknessAbsGradientx/ThicknessAbsGradientx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ThicknessAbsGradientx/ThicknessAbsGradientx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ThicknessAbsGradientx/ThicknessAbsGradientx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/ThicknessAbsMisfitx/ThicknessAbsMisfitx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ThicknessAbsMisfitx/ThicknessAbsMisfitx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ThicknessAbsMisfitx/ThicknessAbsMisfitx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/TimeAdaptx/TimeAdaptx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/TimeAdaptx/TimeAdaptx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/TimeAdaptx/TimeAdaptx.cpp	(revision 12878)
@@ -10,15 +10,15 @@
 #include "../../Container/Container.h"
 
-void TimeAdaptx(double* pdt, Elements* elements, Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials, Parameters* parameters){
+void TimeAdaptx(IssmDouble* pdt, Elements* elements, Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials, Parameters* parameters){
 
 	int      i;
 
 	/*output: */
-	double   dt;
+	IssmDouble   dt;
 
 	/*intermediary: */
 	Element *element     = NULL;
-	double   min_dt      = 0;
-	double   node_min_dt = 0;
+	IssmDouble   min_dt      = 0;
+	IssmDouble   node_min_dt = 0;
 
 	/*Go through elements, and figure out the minimum of the time steps for each element (using CFL criterion): */
Index: issm/branches/trunk-jpl-damage/src/c/modules/TimeAdaptx/TimeAdaptx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/TimeAdaptx/TimeAdaptx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/TimeAdaptx/TimeAdaptx.h	(revision 12878)
@@ -6,8 +6,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void TimeAdaptx(double* pdt, Elements* elements, Nodes* nodes,Vertices* vertices,Loads* loads, Materials* materials, Parameters* parameters);
+void TimeAdaptx(IssmDouble* pdt, Elements* elements, Nodes* nodes,Vertices* vertices,Loads* loads, Materials* materials, Parameters* parameters);
 
 #endif  /* _TIMEADAPTX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/TotalSmbx/TotalSmbx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/TotalSmbx/TotalSmbx.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/modules/TotalSmbx/TotalSmbx.cpp	(revision 12878)
@@ -0,0 +1,30 @@
+/*!\file TotalSmbx
+ * \brief: compute total ice sheet surface mass balance 
+ */
+
+#include "./TotalSmbx.h"
+
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../toolkits/toolkits.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+
+void TotalSmbx(double* pSmb, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
+
+	double local_smb = 0;
+	double total_smb;
+
+	for(int i=0;i<elements->Size();i++){
+		Element* element=(Element*)elements->GetObjectByOffset(i);
+		local_smb+=element->TotalSmb();
+	}
+	#ifdef _HAVE_MPI_
+	MPI_Reduce(&local_smb,&total_smb,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD );
+	MPI_Bcast(&total_smb,1,MPI_DOUBLE,0,MPI_COMM_WORLD);
+	#else
+	total_smb=local_smb;
+	#endif
+
+	/*Assign output pointers: */
+	*pSmb=total_smb;
+}
Index: issm/branches/trunk-jpl-damage/src/c/modules/TotalSmbx/TotalSmbx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/TotalSmbx/TotalSmbx.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/modules/TotalSmbx/TotalSmbx.h	(revision 12878)
@@ -0,0 +1,14 @@
+/*!\file:  TotalSmbx.h
+ * \brief header file for inverse methods misfit computation
+ */ 
+
+#ifndef _TOTALSMBX_H
+#define _TOTALSMBX_H
+
+#include "../../Container/Container.h"
+#include "../../classes/objects/objects.h"
+
+/* local prototypes: */
+void TotalSmbx(double* pSmb, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
+
+#endif
Index: issm/branches/trunk-jpl-damage/src/c/modules/TriMeshx/TriMeshx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/TriMeshx/TriMeshx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/TriMeshx/TriMeshx.cpp	(revision 12878)
@@ -57,5 +57,5 @@
 
 	/*fill in the point list: */
-	in.pointlist = (REAL *) xmalloc(in.numberofpoints * 2 * sizeof(REAL));
+	in.pointlist = xNew<REAL>(in.numberofpoints*2);
 
 	counter=0;
@@ -78,9 +78,9 @@
 	
 	/*fill in the point attribute list: */
-	in.pointattributelist = (REAL*)xmalloc(in.numberofpoints*in.numberofpointattributes*sizeof(REAL));
+	in.pointattributelist = xNew<REAL>(in.numberofpoints*in.numberofpointattributes);
 	for (i=0;i<in.numberofpoints;i++) in.pointattributelist[i] = 0.0;
 	
 	/*fill in the point marker list: */
-	in.pointmarkerlist = (int *) xmalloc(in.numberofpoints * sizeof(int));
+	in.pointmarkerlist = xNew<int>(in.numberofpoints);
 	for(i=0;i<in.numberofpoints;i++) in.pointmarkerlist[i] = 0;
 
@@ -97,6 +97,6 @@
 	}
 	
-	in.segmentlist = (int *) xmalloc(in.numberofsegments * 2 * sizeof(int));
-	in.segmentmarkerlist = (int *) xcalloc(in.numberofsegments,sizeof(int));
+	in.segmentlist = xNew<int>(in.numberofsegments*2);
+	in.segmentmarkerlist = xNewZeroInit<int>(in.numberofsegments);
 	counter=0;
 	backcounter=0;
@@ -135,5 +135,5 @@
 	in.numberofholes = domain->Size()-1; /*everything is a hole, but for the first profile.*/
 	if(in.numberofholes){
-		in.holelist = (REAL *) xmalloc(in.numberofholes * 2 * sizeof(REAL));
+		in.holelist = xNew<REAL>(in.numberofholes*2);
 		for (i=0;i<domain->Size()-1;i++){
 			contour=(Contour*)domain->GetObjectByOffset(i+1);
@@ -164,9 +164,9 @@
 
 	/*Allocate index, x and y: */
-	index=(double*)xmalloc(3*out.numberoftriangles*sizeof(double));
-	x=(double*)xmalloc(out.numberofpoints*sizeof(double));
-	y=(double*)xmalloc(out.numberofpoints*sizeof(double));
-	segments=(double*)xmalloc(3*out.numberofsegments*sizeof(double));
-	segmentmarkerlist=(double*)xmalloc(out.numberofsegments*sizeof(double));
+	index=xNew<double>(3*out.numberoftriangles);
+	x=xNew<double>(out.numberofpoints);
+	y=xNew<double>(out.numberofpoints);
+	segments=xNew<double>(3*out.numberofsegments);
+	segmentmarkerlist=xNew<double>(out.numberofsegments);
 
 	for (i = 0; i< out.numberoftriangles; i++) {
@@ -192,13 +192,12 @@
 
 	/*Output : */
-	index_matrix=new Matrix(index,out.numberoftriangles,3,1); 
-	index_matrix->Convert(DENSE_SEQUENTIAL);
+	index_matrix=new Matrix(index,out.numberoftriangles,3,1,SeqMatType);
 	*pindex=index_matrix;
 	
-	segments_matrix=new Matrix(segments,out.numberofsegments,3,1); segments_matrix->Convert(DENSE_SEQUENTIAL);
+	segments_matrix=new Matrix(segments,out.numberofsegments,3,1,SeqMatType);
 	*psegments=segments_matrix;
 
-	*px=new Vector(x,out.numberofpoints);
-	*py=new Vector(y,out.numberofpoints);
-	*psegmentmarkerlist=new Vector(segmentmarkerlist,out.numberofsegments);
+	*px=new Vector(x,out.numberofpoints,SeqMatType);
+	*py=new Vector(y,out.numberofpoints,SeqMatType);
+	*psegmentmarkerlist=new Vector(segmentmarkerlist,out.numberofsegments,SeqMatType);
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/TriMeshx/TriMeshx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/TriMeshx/TriMeshx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/TriMeshx/TriMeshx.h	(revision 12878)
@@ -8,5 +8,5 @@
 #include "string.h"
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/TriaSearchx/TriaSearchx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/TriaSearchx/TriaSearchx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/TriaSearchx/TriaSearchx.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../include/include.h"
 #include "../../toolkits/toolkits.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../modules.h"
 
@@ -13,5 +13,5 @@
 using namespace std;
 
-void TriaSearchx(double** ptria,double* index,int nel, double* x, double* y, int nods,double* x0, double* y0,int numberofnodes){
+void TriaSearchx(double** ptria,int* index,int nel, double* x, double* y, int nods,double* x0, double* y0,int numberofnodes){
 
 	/*Output*/
@@ -19,5 +19,5 @@
 
 	/*allocate: */
-	tria=(double*)xmalloc(numberofnodes*sizeof(double));
+	tria=xNew<double>(numberofnodes);
 
 	/*Intermediary*/
@@ -52,5 +52,4 @@
 	}
 
-
 	/*Assign output pointers:*/
 	*ptria=tria;
Index: issm/branches/trunk-jpl-damage/src/c/modules/TriaSearchx/TriaSearchx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/TriaSearchx/TriaSearchx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/TriaSearchx/TriaSearchx.h	(revision 12878)
@@ -6,8 +6,8 @@
 #define _TRIASEARCHX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void TriaSearchx(double** ptria,double* index,int nel, double* x, double* y, int nods,double* x0, double* y0,int numberofnodes);
+void TriaSearchx(double** ptria,int* index,int nel, double* x, double* y, int nods,double* x0, double* y0,int numberofnodes);
 
 #endif
Index: issm/branches/trunk-jpl-damage/src/c/modules/UpdateConstraintsx/UpdateConstraintsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/UpdateConstraintsx/UpdateConstraintsx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/UpdateConstraintsx/UpdateConstraintsx.cpp	(revision 12878)
@@ -14,5 +14,5 @@
 void UpdateConstraintsx(Nodes* nodes,Constraints* constraints,Parameters* parameters){
 
-	double time;
+	IssmDouble time;
 	int    analysis_type;
 
@@ -22,5 +22,5 @@
 
 	/*start module: */
-	_printf_(VerboseModule(),"%s%g\n","   Updating constraints for time: ",time);
+	if(VerboseModule()) _pprintLine_("   Updating constraints for time: " << time);
 	
 	/*First, update dof constraints in nodes, using constraints: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/UpdateConstraintsx/UpdateConstraintsx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/UpdateConstraintsx/UpdateConstraintsx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/UpdateConstraintsx/UpdateConstraintsx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _UPDATECONSTRAINTSX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 #include "../../toolkits/toolkits.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/UpdateDynamicConstraintsx/UpdateDynamicConstraintsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/UpdateDynamicConstraintsx/UpdateDynamicConstraintsx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/UpdateDynamicConstraintsx/UpdateDynamicConstraintsx.cpp	(revision 12878)
@@ -13,5 +13,5 @@
 	
 	int configuration_type;
-	double* yg_serial=NULL;
+	IssmDouble* yg_serial=NULL;
 
 	/*Get current configuration*/
@@ -34,4 +34,4 @@
 
 	/*Free ressources:*/
-	xfree((void**)&yg_serial);
+	xDelete<IssmDouble>(yg_serial);
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/UpdateDynamicConstraintsx/UpdateDynamicConstraintsx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/UpdateDynamicConstraintsx/UpdateDynamicConstraintsx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/UpdateDynamicConstraintsx/UpdateDynamicConstraintsx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 void UpdateDynamicConstraintsx(Constraints* constraints,Nodes* nodes,Parameters* parameters,Vector* yg);
Index: issm/branches/trunk-jpl-damage/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.cpp	(revision 12878)
@@ -15,6 +15,6 @@
 	Vector*     vz        = NULL;
 	Vertex *vertex    = NULL;
-	double *thickness = NULL;
-	double *bed       = NULL;
+	IssmDouble *thickness = NULL;
+	IssmDouble *bed       = NULL;
 
 	/*get vertex vectors for bed and thickness: */
@@ -38,6 +38,6 @@
 
 	/*Free ressources:*/
-	xfree((void**)&thickness);
-	xfree((void**)&bed);
+	xDelete<IssmDouble>(thickness);
+	xDelete<IssmDouble>(bed);
 	xdelete(&vz);
 	return 1;
Index: issm/branches/trunk-jpl-damage/src/c/modules/VecMergex/VecMergex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/VecMergex/VecMergex.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/VecMergex/VecMergex.cpp	(revision 12878)
@@ -15,5 +15,5 @@
 	int i;
 	int configuration_type;
-	double* uf_serial=NULL;
+	IssmDouble* uf_serial=NULL;
 
 	/*retrieve parameters: */
@@ -41,5 +41,5 @@
 	}
 	/*Free ressources:*/
-	xfree((void**)&uf_serial);
+	xDelete<IssmDouble>(uf_serial);
 
 	/*Assemble vector: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/VecMergex/VecMergex.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/VecMergex/VecMergex.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/VecMergex/VecMergex.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/VerticesDofx/VerticesDofx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/VerticesDofx/VerticesDofx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/VerticesDofx/VerticesDofx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Xy2llx/Xy2llx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Xy2llx/Xy2llx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Xy2llx/Xy2llx.cpp	(revision 12878)
@@ -53,5 +53,5 @@
 	double  sl,rho,cm,T,chi;
 
-	if((sgn!=1) && (sgn!=-1)) _error_("Sign should be either +1 or -1.\n");
+	if((sgn!=1) && (sgn!=-1)) _error2_("Sign should be either +1 or -1.\n");
 
 	delta = central_meridian;
@@ -124,12 +124,12 @@
 		*pdelta= 45;
 		*pslat = 70;
-		_printf_(flag,"Warning: expecting coordinates in polar stereographic (Std Latitude: 70N Meridian: 45).\n");
+		if(flag) _pprintLine_("Warning: expecting coordinates in polar stereographic (Std Latitude: 70N Meridian: 45).");
 	}
 	else if (sgn == -1) {
 		*pdelta= 0;
 		*pslat = 71;
-		_printf_(flag,"Warning: expecting coordinates in polar stereographic (Std Latitude: 71S Meridian: 0).\n");
+		if(flag) _pprintLine_("Warning: expecting coordinates in polar stereographic (Std Latitude: 71S Meridian: 0).");
 	}
-	else _error_("Sign should be either +1 or -1.\n");
+	else _error2_("Sign should be either +1 or -1.\n");
 
 	return;
Index: issm/branches/trunk-jpl-damage/src/c/modules/modules.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/modules.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/modules.h	(revision 12878)
@@ -25,4 +25,5 @@
 #include "./CreateNodalConstraintsx/CreateNodalConstraintsx.h"
 #include "./DakotaResponsesx/DakotaResponsesx.h"
+#include "./Delta18oParameterizationx/Delta18oParameterizationx.h"
 #include "./DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.h"
 #include "./ElementConnectivityx/ElementConnectivityx.h"
@@ -36,4 +37,5 @@
 #include "./GroundinglineMigrationx/GroundinglineMigrationx.h"
 #include "./HoleFillerx/HoleFillerx.h"
+#include "./TotalSmbx/TotalSmbx.h"
 #include "./IceVolumex/IceVolumex.h"
 #include "./InputControlUpdatex/InputControlUpdatex.h"
@@ -94,4 +96,5 @@
 #include "./ConstraintsStatex/ConstraintsStatex.h"
 #include "./PointCloudFindNeighborsx/PointCloudFindNeighborsx.h"
+#include "./PositiveDegreeDayx/PositiveDegreeDayx.h"
 #include "./PropagateFlagsFromConnectivityx/PropagateFlagsFromConnectivityx.h"
 #include "./Dakotax/Dakotax.h"
@@ -105,4 +108,5 @@
 #include "./RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.h"
 #include "./Scotchx/Scotchx.h"
+#include "./SmbGradientsx/SmbGradientsx.h"
 #include "./Solverx/Solverx.h"
 #include "./SpcNodesx/SpcNodesx.h"
@@ -120,4 +124,3 @@
 #include "./VerticesDofx/VerticesDofx.h"
 #include "./VecMergex/VecMergex.h"
-
 #endif
Index: issm/branches/trunk-jpl-damage/src/c/python/include/python_macros.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/python/include/python_macros.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/python/include/python_macros.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _PYTHON_MACROS_H_
 
-/*Header {{{1*/
+/*Header {{{*/
 
 #ifdef HAVE_CONFIG_H
@@ -16,5 +16,5 @@
 
 #ifdef _HAVE_PYTHON_
-/* MODULEBOOT/MODULEEND {{{1*/
+/* MODULEBOOT/MODULEEND {{{*/
 
 /*The following macros hide the error exception handling in a matlab module. Just put 
@@ -30,5 +30,5 @@
 //}}}
 #if _PYTHON_MAJOR_ >=3
-/* WRAPPER 3.2 {{{1*/
+/* WRAPPER 3.2 {{{*/
 #define WRAPPER(modulename,...)  \
 \
@@ -57,5 +57,5 @@
 /*}}}*/
 #else
-/* WRAPPER 2.7 {{{1*/
+/* WRAPPER 2.7 {{{*/
 #define WRAPPER(modulename,...)  \
 \
@@ -75,5 +75,5 @@
 /*}}}*/
 #endif
-/* CHECKARGUMENTS {{{1*/
+/* CHECKARGUMENTS {{{*/
 #define CHECKARGUMENTS(NLHS,NRHS,functionpointer) CheckNumPythonArguments(args, NRHS,functionpointer)
 /*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/python/io/CheckNumPythonArguments.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/python/io/CheckNumPythonArguments.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/python/io/CheckNumPythonArguments.cpp	(revision 12878)
@@ -27,9 +27,9 @@
 	if (size==0){
 		function();
-		_error_("usage: see above");
+		_error2_("usage: see above");
 	}
 	else if (size!=NRHS ) {
 		function(); 
-		_error_("usage error.");
+		_error2_("usage error.");
 	}
 	return 1;
Index: issm/branches/trunk-jpl-damage/src/c/python/io/FetchPythonData.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/python/io/FetchPythonData.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/python/io/FetchPythonData.cpp	(revision 12878)
@@ -15,7 +15,8 @@
 #include "../../include/include.h"
 #include "../../shared/shared.h"
+#include "../../io/io.h"
 
 /*Primitive data types*/
-/*FUNCTION FetchData(double* pscalar,PyObject* py_float){{{1*/
+/*FUNCTION FetchData(double* pscalar,PyObject* py_float){{{*/
 void FetchData(double* pscalar,PyObject* py_float){
 
@@ -29,5 +30,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(int* pinteger,PyObject* py_long){{{1*/
+/*FUNCTION FetchData(int* pinteger,PyObject* py_long){{{*/
 void FetchData(int* pinteger, PyObject* py_long){
 
@@ -41,5 +42,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(bool* pboolean,PyObject* py_boolean){{{1*/
+/*FUNCTION FetchData(bool* pboolean,PyObject* py_boolean){{{*/
 void FetchData(bool* pboolean,PyObject* py_boolean){
 
@@ -47,5 +48,5 @@
 	
 	/*check this is indeed a subtype of long type: */
-	if(!PyBool_Check(py_boolean))_error_("expecting a boolean in input!");
+	if(!PyBool_Check(py_boolean))_error2_("expecting a boolean in input!");
 
 	/*extract boolean: */
@@ -57,5 +58,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(double** pmatrix,int* pM, int* pN, PyObject* py_matrix){{{1*/
+/*FUNCTION FetchData(double** pmatrix,int* pM, int* pN, PyObject* py_matrix){{{*/
 void FetchData(double** pmatrix,int* pM,int *pN,PyObject* py_matrix){
 
@@ -68,5 +69,5 @@
 	/*retrive dimensions: */
 	ndim=PyArray_NDIM((const PyArrayObject*)py_matrix);
-	if(ndim!=2)_error_("expecting an MxN matrix in input!");
+	if(ndim!=2)_error2_("expecting an MxN matrix in input!");
 	dims=PyArray_DIMS((PyArrayObject*)py_matrix);
 	M=dims[0]; N=dims[1];
@@ -81,5 +82,37 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(double** pvector,int* pM, PyObject* py_vector){{{1*/
+/*FUNCTION FetchData(int** pmatrix,int* pM, int* pN, PyObject* py_matrix){{{*/
+void FetchData(int** pmatrix,int* pM,int *pN,PyObject* py_matrix){
+
+	/*output: */
+	double* dmatrix=NULL;
+	int* matrix=NULL;
+	int M,N;
+
+	/*intermediary:*/
+	int i;
+	int ndim;
+	npy_intp*  dims=NULL;
+
+	/*retrive dimensions: */
+	ndim=PyArray_NDIM((const PyArrayObject*)py_matrix);
+	if(ndim!=2)_error2_("expecting an MxN matrix in input!");
+	dims=PyArray_DIMS((PyArrayObject*)py_matrix);
+	M=dims[0]; N=dims[1];
+	
+	/*retrieve internal value: */
+	dmatrix=(double*)PyArray_DATA((PyArrayObject*)py_matrix);
+
+	/*transform into integer matrix: */
+	matrix=xNew<int>(M*N);
+	for(i=0;i<M*N;i++)matrix[i]=(int)dmatrix[i];
+
+	/*output: */
+	if(pM)*pM=M;
+	if(pN)*pN=N;
+	if(pmatrix)*pmatrix=matrix;
+}
+/*}}}*/
+/*FUNCTION FetchData(double** pvector,int* pM, PyObject* py_vector){{{*/
 void FetchData(double** pvector,int* pM,PyObject* py_vector){
 
@@ -92,5 +125,5 @@
 	/*retrive dimensions: */
 	ndim=PyArray_NDIM((const PyArrayObject*)py_vector);
-	if(ndim!=1)_error_("expecting an Mx1 vector in input!");
+	if(ndim!=1)_error2_("expecting an Mx1 vector in input!");
 	dims=PyArray_DIMS((PyArrayObject*)py_vector);
 	M=dims[0]; 
@@ -104,8 +137,21 @@
 }
 /*}}}*/
+/*FUNCTION FetchData(Options** poptions,int istart, int nrhs,PyObject* arguments){{{*/
+void FetchData(Options** poptions,int istart, int nrhs,PyObject* arguments){
+
+	/*Initialize output*/
+	Options* options=new Options();
+
+	_pprintLine_("FetchData for Options not implemented yet, ignoring them!");
+
+	/*Assign output pointers:*/
+	*poptions=options;
+
+}
+/*}}}*/
 
 /*Python version dependent: */
 #if _PYTHON_MAJOR_ >= 3 
-/*FUNCTION FetchData(char** pstring,PyObject* py_unicode){{{1*/
+/*FUNCTION FetchData(char** pstring,PyObject* py_unicode){{{*/
 void FetchData(char** pstring,PyObject* py_unicode){
 
@@ -124,5 +170,5 @@
 /*}}}*/
 #else
-/*FUNCTION FetchData(char** pstring,PyObject* py_string){{{1*/
+/*FUNCTION FetchData(char** pstring,PyObject* py_string){{{*/
 void FetchData(char** pstring,PyObject* py_string){
 
Index: issm/branches/trunk-jpl-damage/src/c/python/io/WritePythonData.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/python/io/WritePythonData.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/python/io/WritePythonData.cpp	(revision 12878)
@@ -21,12 +21,11 @@
 
 
-/*FUNCTION WriteData(PyObject* py_tuple,int index,char* string){{{1*/
+/*FUNCTION WriteData(PyObject* py_tuple,int index,char* string){{{*/
 void WriteData(PyObject* py_tuple, int index, char* string){
 	
 	PyTuple_SetItem(py_tuple, index, PyUnicode_FromString(string));
 
-}
-/*}}}*/
-/*FUNCTION WriteData(PyObject* tuple,int index,Matrix* matrix){{{1*/
+}/*}}}*/
+/*FUNCTION WriteData(PyObject* tuple,int index,Matrix* matrix){{{*/
 void WriteData(PyObject* tuple,int index,Matrix* matrix){
 	
@@ -45,6 +44,6 @@
 
 
-}
-/*FUNCTION WriteData(PyObject* py_tuple,int index,Vector* vector){{{1*/
+}/*}}}*/
+/*FUNCTION WriteData(PyObject* py_tuple,int index,Vector* vector){{{*/
 void WriteData(PyObject* tuple,int index,Vector* vector){
 	
@@ -64,5 +63,5 @@
 }
 /*}}}*/
-/*FUNCTION WriteData(PyObject* py_tuple,int index, double* matrix, int M, int N){{{1*/
+/*FUNCTION WriteData(PyObject* py_tuple,int index, double* matrix, int M, int N){{{*/
 void WriteData(PyObject* tuple, int index, double* matrix, int M,int N){
 	
@@ -76,3 +75,3 @@
 	PyTuple_SetItem(tuple, index, array);
 
-}
+}/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/python/io/pythonio.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/python/io/pythonio.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/python/io/pythonio.h	(revision 12878)
@@ -13,5 +13,5 @@
 
 
-#include "../../objects/objects.h"
+#include "../../classes/classes.h"
 #include "../../Container/Container.h"
 #include "../../include/include.h"
@@ -47,8 +47,10 @@
 void FetchData(double** pvector,int* pM,PyObject* py_ref);
 void FetchData(double** pmatrix,int* pM,int *pN,PyObject* py_array);
+void FetchData(int** pmatrix,int* pM,int *pN,PyObject* py_matrix);
 void FetchData(char** pstring,PyObject* py_unicode);
 void FetchData(double* pscalar,PyObject* py_float);
 void FetchData(int* pinteger,PyObject* py_long);
 void FetchData(bool* pbool,PyObject* py_boolean);
+void FetchData(Options** poptions,int istart, int nrhs,PyObject* arguments);
 
 int CheckNumPythonArguments(PyObject* inputs,int NRHS, void (*function)( void ));
